//+------------------------------------------------------------------+
//|                         ENTRY/EXIT Bollinger signal indicator    |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 6

#property indicator_color1 DeepSkyBlue
#property indicator_color2 Red
#property indicator_color3 CLR_NONE
#property indicator_color4 CLR_NONE

//+------------------------------------------------------------------+
//|                                                indicator setting |
//+------------------------------------------------------------------+

extern int UpperLineBollingerperid = 11;
extern int LowerLineBollingerperid = 11;
extern int stdev = 3;
extern int arrowwidth = 5;

//bool dummy = 1;
//+------------------------------------------------------------------+
//|                                       Custom indicator buffers   |
//+------------------------------------------------------------------+

double upbuy[];
double dnsell[];
double uupbuy[];
double ddnsell[];

//double upperBLine[];
//double lowerBLine[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+


int init() {
  
   SetIndexBuffer(0, upbuy); SetIndexStyle(0, DRAW_ARROW, STYLE_DOT, arrowwidth);
   SetIndexArrow (0, 233);
   
   SetIndexBuffer(1, dnsell); SetIndexStyle(1, DRAW_ARROW, STYLE_DOT, arrowwidth);
   SetIndexArrow (1, 234);         
   
   SetIndexBuffer(2, uupbuy); SetIndexStyle(4, DRAW_NONE);
   SetIndexBuffer(3, ddnsell); SetIndexStyle(5, DRAW_NONE);
   
   IndicatorShortName(" Entry/Exit Bollinger signal indicator");
   
   return (0);
}

int start() {
   double barvalue; double diff1;
   
  fuction1();
   int counted_bars = IndicatorCounted();
   if (counted_bars < 0) return (-1);
   if (counted_bars > 0) counted_bars--;
   
   int limit = Bars - counted_bars;
    for (int i = limit; i > 0; i--) {
      if (k(i)) { barvalue = High[i]; }
      if (kk(i)) {barvalue = Low [i]; }
         diff1 = barvalue - Close[i];
      }
   return (0);
}


int k(int j) {
   if (dnsell[j] == EMPTY_VALUE) return (0);
   return (dnsell[j] > 0.0);
}


int kk(int j) {
   if (upbuy[j] == EMPTY_VALUE) return (0);
   return (upbuy[j] > 0.0);
}

//+------------------------------------------------------------------+
//                                             Indicator Calculation |                    |
//+------------------------------------------------------------------+
void fuction1() {
   int yy;
   int dummy = 1;
   
   double upperBLine[1000];
   double lowerBLine[1000];
   
   
   for (int i = 1000; i > 0; i--) {
      
      upperBLine[i] = iBands(NULL, 0, UpperLineBollingerperid, stdev, 0, PRICE_CLOSE, MODE_UPPER, i);
      lowerBLine[i] = iBands(NULL, 0, LowerLineBollingerperid, stdev, 0, PRICE_CLOSE, MODE_LOWER, i);
      
      if (Close[i] > upperBLine[i + 1]) yy = 1;
      if (Close[i] < lowerBLine[i + 1]) yy = -1;
      if (yy > 0 && lowerBLine[i] < lowerBLine[i + 1]) lowerBLine[i] = lowerBLine[i + 1];
      if (yy < 0 && upperBLine[i] > upperBLine[i + 1]) upperBLine[i] = upperBLine[i + 1];
      if (yy > 0) {
         if (dummy > 0 && uupbuy[i + 1] == -1.0) {
            upbuy[i] = lowerBLine[i];
            
         } else {
            
            upbuy[i] = EMPTY_VALUE;
         }
         if (dummy == 2) uupbuy[i] = 0;
         dnsell[i] = EMPTY_VALUE;
         ddnsell[i] = -1.0;
      }
      if (yy < 0) {
         if (dummy > 0 && ddnsell[i + 1] == -1.0) {
            dnsell[i] = upperBLine[i];
            
         } else {
           
            dnsell[i] = EMPTY_VALUE;
         }
         if (dummy == 2) ddnsell[i] = 0;
         upbuy[i] = EMPTY_VALUE;
         uupbuy[i] = -1.0;
      }
   }
}

